<template>
  <div>
    <Modal v-model="showModal" width="1200" class="modal-footer-none">
      <p slot="header">{{modalTitle}}</p>
      <div>
        <!--内容-->
        <Row>
          <!--查询-->
          <Col span="24">
            <Form id="formId" :label-width="80" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item label="样品名称:" class="search-item">
                <Input v-model="formObj.name" placeholder="请输入样品名称" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item label="样品编号:" class="search-item">
                <Input v-model="formObj.code" placeholder="请输入样品编号" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-btn" style="margin-left: -10px">
                <Button type="primary" @click="_formSearch">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" class="contHide"
                      @on-result-change="_btnClick"></btn-list>
          </Col>
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :get-page="getPage"
                        :icon-msg="iconMsg" select-data @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <div v-if="item.detail"><a @click.stop="_detailModal(scope.row.id)">{{scope.row[item.key]}}</a></div>
                  <div v-else-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}
                  </div>
                  <div v-else-if="item.key==='jobOut'">
                     {{scope.row[item.key]===1?'是':'否'}}
                  </div>
<!--                  <div v-else-if="item.key==='type'">-->
<!--                    <Select v-model="scope.row.type">-->
<!--                      <Option v-for="(item,index) in options" :key="item.name" :value="index">-->
<!--                        {{ item.name }}-->
<!--                      </Option>-->
<!--                    </Select>-->
<!--                  </div>-->
                  <div v-else>{{scope.row[item.key]}}</div>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </Modal>
  </div>
</template>
<script>
import { meterSample } from '../../../api'
export default {
  components: {},
  data() {
    return {
      currentComponent: '',
      searchOpen: false,
      // btn: [
      //   {type: 'success', id: '', name: '添加', componentName: 'FoodSampleGovernEdit'},
      //   {id: 'food-gov-sample-batch-add', name: '批量添加', componentName: 'FoodSampleGovernBatchAdd'},
      //   {id: '', name: '导入样品', componentName: 'FoodImportSample'},
      //   {id: '', name: '导入检测项目', componentName: 'RelItem'},
      //   {id: '', name: '导入检测项目包', componentName: 'RelItemPackage'},
      //   {id: '', name: '复制历史样品检测项目', componentName: 'CopyHisItem'},
      //   {id: '', name: '删除'},
      // ],
      iconMsg: [
        {
          type: 'ios-book',
          id: '',
          name: '查看当前版本证书'
        }
      ],
      btn: [],
      options: [
        {
          name: '检定'
        },
        {
          name: '校准'
        },
        {
          name: '外观检查'
        }
      ],
      formId: 'meterReviewSampleManageFormId',
      showModal: false,
      modalTitle: '管理样品',
      selectIds: [],
      selectData: [],
      getPage: {},
      pageColumns: [
        { title: '修改人', key: 'uname', width: 120 },
        { title: '修改时间', key: 'ctime', width: 140, date: true },
        { title: '证书版本', key: 'version', width: 140 },
        { title: '备注', key: 'remark', width: 140 }
      ],
      dateList: [],
      formObj: {
        sampleId: undefined,
        name: undefined,
        code: undefined,
        type: undefined
      }
    }
  },
  computed: {
    tableHeight: function() {
      return this.$tableHeight('tableModal')
    }
  },
  methods: {
    _dateChange(data) {
      this.formObj.ctimeBegin = data[0]
      this.formObj.ctimeEnd = data[1]
    },
    _viewReport(data) {
      if (data) {
        this.$openWindowModeless({
          objectKey: data.objectKey,
          idType: 10,
          id: data.id,
          isReport: 5
        })
      }
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '取消分包':
            this._subpackageCancelBtn()
            break
        }
      })
    },
    _subpackageCancelBtn() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选择一条数据！')
      } else {
        const data = {}
        data.ids = this.selectIds.join(',')
        this._subpackageCancel(data)
      }
    },
    _subpackageCancel: async function(data) {
      console.log(data)
      const result = await meterSample.subpackageCancel(data)
      if (result) {
        this.$Message.success('取消成功!')
        await this._page()
      }
    },
    _outWarehouse() {
      if (this.selectData.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        for (let i = 0; i < this.selectData.length; i++) {
          const obj = this.selectData[i]
          if (obj.subcontractor === undefined) {
            this.$Message.warning('请先填写分包信息在进行此操作！')
            return false
          }
        }
        this.$refs.OutWarehouseModal._open(this.selectIds, this.selectData)
      }
    },
    _batchEpiboly() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this.$refs.batchEditModal._open(this.selectIds, this.selectData)
      }
    },
    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '查看当前版本证书':
            this._viewReport(data)
            break
        }
      })
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'selectData':
          const selectIds = []
          for (let i = 0; i < data.length; i++) {
            selectIds.push(data[i].id)
          }
          this.selectIds = selectIds
          this.selectData = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _open(id) {
      this.formObj.sampleId = id
      this.showModal = true
      this._page()
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      this.selectIds = []
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await meterSample.pageCertificate(this.formObj)
      if (result) {
        this.getPage = result
        this.$refs.pageTable._hideLoading()
      }
    },
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this.$store.dispatch('FoodSample/deleteByIds', ids).then(() => {
            this._resultChange('删除成功!')
          })
        }
      })
    },
    _deleteById(id) {
      // 删除一条记录
      this._deleteByIds([id])
    },
    _deleteSelected() {
      // 批量删除
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this._deleteByIds(ids, '确定删除 ' + ids.length + ' 条记录？')
      }
    },
    _editModal(edit, id) {
      this.currentComponent = 'FoodSampleGovernEdit'
      this.$nextTick(function() {
        if (edit) {
          this.$store.dispatch('FoodSample/getByGovernId', id).then(() => {
            this.$refs.refModal._open(
              this.$store.state.FoodSample.governModel,
              this.contractId
            )
          })
        } else {
          this.$refs.refModal._open('', this.contractId)
        }
      })
    },
    _editLY(id) {
      // 粮油的编辑
      this.currentComponent = 'FoodSampleGovernLYEdit'
      this.$nextTick(function() {
        this.$store.dispatch('FoodSample/getByGovernId', id).then(() => {
          this.$refs.refModal._open(
            this.$store.state.FoodSample.governModel,
            this.contractId
          )
        })
      })
    },
    _search() {
      this._page()
    },
    _searchParams() {
      const data = this.$serialize('search-sample-govern')
      return this.$extend(data, this.pageParams)
    },
    _resultChange(msg) {
      if (this.$store.state.FoodSample.success) {
        this._page()
        this.$Message.success(msg)
      }
    },
    _copy(sampleId, type) {
      this.$refs.refModal._open(sampleId, type)
    },
    // 复制样品
    _copySample(data) {
      if (data.type === 2) {
        // 粮油的编辑页
        this.currentComponent = 'FoodSampleGovernLYEdit'
        this.$store
          .dispatch('FoodSample/getByGovernId', data.sampleId)
          .then(() => {
            this.$nextTick(function() {
              this.$refs.refModal._openCopySample(
                this.$store.state.FoodSample.governModel
              )
            })
          })
      } else {
        this.currentComponent = 'FoodSampleGovernEdit'
        this.$store
          .dispatch('FoodSample/getByGovernId', data.sampleId)
          .then(() => {
            this.$nextTick(function() {
              this.$refs.refModal._openCopySample(
                this.$store.state.FoodSample.governModel
              )
            })
          })
      }
    },
    _copyAll(data) {
      if (data.type === 2) {
        // 粮油的编辑页
        this.currentComponent = 'FoodSampleGovernLYEdit'
        this.$store
          .dispatch('FoodSample/getByGovernId', data.sampleId)
          .then(() => {
            this.$nextTick(function() {
              this.$refs.refModal._openCopyAll(
                this.$store.state.FoodSample.governModel
              )
            })
          })
      } else {
        this.currentComponent = 'FoodSampleGovernEdit'
        this.$store
          .dispatch('FoodSample/getByGovernId', data.sampleId)
          .then(() => {
            this.$nextTick(function() {
              this.$refs.refModal._openCopyAll(
                this.$store.state.FoodSample.governModel
              )
            })
          })
      }
    },
    // 导入样品
    _importSample() {
      const data = {
        importUrl: '/food/v1/sample/government/import_' + this.contractId,
        downloadUrl: '/food/v1/excel/template/FoodSampleGovernment',
        title: '导入'
      }
      this.$refs.refModal._open(data)
    },
    // 导入检测项目
    _importItem() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds, this.selectData[0])
      }
    },
    _importItemPackage() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds, 'batch-rel-package-item')
      }
    },
    _copyHisItem() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds)
      }
    },
    _itemDetail(id) {
      this.$refs.foodItem._open(id)
    },
    _operationRecord(id) {
      // 操作日志
      this.$refs.recordModal._open(id)
    }
  }
}
</script>
